cmake_minimum_required(VERSION 3.11)

# Freetype parameters
set(BUILD_SHARED_LIBS OFF CACHE BOOL "" FORCE)
# Freetype
include(FetchContent)
FetchContent_Declare(
  freetype
  DOWNLOAD_EXTRACT_TIMESTAMP OFF
  GIT_REPOSITORY    https://gitlab.freedesktop.org/freetype/freetype.git
  GIT_TAG           VER-2-13-3
)
FetchContent_GetProperties(freetype)
if (NOT freetype_POPULATED)
  set(FETCHCONTENT_QUIET NO)
  FetchContent_MakeAvailable(freetype)
endif()

# RML UI parameters
set(BUILD_SHARED_LIBS ON CACHE BOOL "" FORCE)
set(Freetype_ROOT ${freetype_SOURCE_DIR} CACHE PATH "Path to freetype root" FORCE)
add_library(Freetype::Freetype ALIAS freetype)
# RML UI
FetchContent_Declare(
  rmlui
  GIT_REPOSITORY https://github.com/mikke89/RmlUi.git
  GIT_TAG        6.1
)
FetchContent_GetProperties(rmlui)
if (NOT rmlui_POPULATED)
  set(FETCHCONTENT_QUIET NO)
  FetchContent_MakeAvailable(rmlui)
endif()
set(RMLUI_INCLUDE_DIRS 
    "${RmlUi_SOURCE_DIR}/Include"
    "${RmlUi_SOURCE_DIR}/Backends"
    "${RmlUi_SOURCE_DIR}/Samples/shell/include"
)
